package atomicstryker.minions.client;

import java.util.ArrayList;

import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.GL11;

import atomicstryker.astarpathing.AStarStatic;
import atomicstryker.minions.client.gui.GuiMinionMenu;
import atomicstryker.minions.client.render.LineColor;
import atomicstryker.minions.client.render.points.PointCube;
import atomicstryker.minions.client.render.region.CuboidRegion;
import atomicstryker.minions.common.MinionsCore;
import atomicstryker.minions.common.codechicken.ChickenLightningBolt;
import atomicstryker.minions.common.codechicken.Vector3;
import atomicstryker.minions.common.entity.EntityMinion;
import atomicstryker.minions.common.network.AssignChestPacket;
import atomicstryker.minions.common.network.ChopTreesPacket;
import atomicstryker.minions.common.network.CustomDigPacket;
import atomicstryker.minions.common.network.DigOreVeinPacket;
import atomicstryker.minions.common.network.DigStairwellPacket;
import atomicstryker.minions.common.network.DropAllPacket;
import atomicstryker.minions.common.network.FollowPacket;
import atomicstryker.minions.common.network.LightningPacket;
import atomicstryker.minions.common.network.MinionSpawnPacket;
import atomicstryker.minions.common.network.MovetoPacket;
import atomicstryker.minions.common.network.PickupEntPacket;
import atomicstryker.minions.common.network.SoundPacket;
import atomicstryker.minions.common.network.StripminePacket;
import net.minecraft.block.Block;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.settings.KeyBinding;
import net.minecraft.entity.Entity;
import net.minecraft.entity.passive.EntityAnimal;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.MathHelper;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.MovingObjectPosition.MovingObjectType;
import net.minecraft.world.World;
import net.minecraftforge.client.event.DrawBlockHighlightEvent;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.client.registry.ClientRegistry;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

import net.minecraft.util.MovingObjectPosition.MovingObjectType;
public class MinionsClient
{
    
    public static boolean isSelectingMineArea = false;
    public static int mineAreaShape = 0;
    public static int customSizeXZ = 3;
    public static int customSizeY = 3;

    public static boolean hasMinionsSMPOverride = false;
    public static boolean hasAllMinionsSMPOverride = false;
    
    private long lastStaffLightningBoltTime = System.currentTimeMillis();
    
    private static long timeNextSoundAllowed = 0L;
    private final static long timeSoundDelay = 400L;
    
    private World lastWorld;
    private static Minecraft mc;
    
    private KeyBinding menuKey;
    
    private static CuboidRegion selection = new CuboidRegion();
    private static ArrayList<PointCube> additionalCubes = new ArrayList<PointCube>();
    
    public MinionsClient()
    {
        mc = FMLClientHandler.instance().getClient();        
        menuKey = new KeyBinding("Minions Menu", Keyboard.KEY_M, "key.categories.gameplay");
        ClientRegistry.registerKeyBinding(menuKey);
    }
    
    @SubscribeEvent
    public void onDrawSelectionBow(DrawBlockHighlightEvent event)
    {
        if (mc.field_71462_r == null && isSelectingMineArea)
        {
            renderSelections(event.partialTicks);
        }
    }
    
    private void renderSelections(float renderTick)
    {
        RenderHelper.func_74518_a();  
        
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
        GL11.glEnable(GL11.GL_BLEND);
        GL11.glDisable(GL11.GL_TEXTURE_2D);
        GL11.glDepthMask(false);
        GL11.glPushMatrix();
        
        EntityPlayer player = mc.field_71439_g;
        double xGuess = player.field_70169_q + (player.field_70165_t - player.field_70169_q) * renderTick;
        double yGuess = player.field_70167_r + (player.field_70163_u - player.field_70167_r) * renderTick;
        double zGuess = player.field_70166_s + (player.field_70161_v - player.field_70166_s) * renderTick;
        GL11.glTranslated(-xGuess, -yGuess, -zGuess);
        GL11.glColor3f(1.0f, 1.0f, 1.0f);
        
        selection.render();

        for (PointCube additionalCube : additionalCubes)
        {
            additionalCube.render();
        }
        
        GL11.glDepthFunc(GL11.GL_LEQUAL);
        GL11.glPopMatrix();
        GL11.glDepthMask(true);
        GL11.glEnable(GL11.GL_TEXTURE_2D);
        GL11.glDisable(GL11.GL_BLEND);
        
        RenderHelper.func_74519_b();
    }
    
    private void setSelectionPoint(int id, int x, int y, int z)
    {
        selection.setCuboidPoint(id, x, y, z);
    }
    
    private void addAdditionalCube(int x, int y, int z)
    {
        PointCube newcube = new PointCube(x, y, z);
        newcube.setColor(LineColor.CUBOIDBOX);
        additionalCubes.add(newcube);
    }
    
    private void deleteAdditionalCubes()
    {
        additionalCubes.clear();
    }
    
    private void deleteSelection()
    {
        selection.wipePointCubes();
        additionalCubes.clear();
    }
    
    public void onRenderTick(float renderTick)
    {
        if (mc.field_71462_r == null && isSelectingMineArea)
        {
            if (mc.field_71439_g.field_71071_by.func_70448_g() == null
            || mc.field_71439_g.field_71071_by.func_70448_g().func_77973_b() != MinionsCore.instance.itemMastersStaff)
            {
                isSelectingMineArea = false;
                deleteSelection();
            }
            else if (mc.field_71476_x != null && mc.field_71476_x.field_72313_a == MovingObjectType.BLOCK)
            {
                int x = mc.field_71476_x.func_178782_a().func_177958_n();
                int y = mc.field_71476_x.func_178782_a().func_177956_o();
                int z = mc.field_71476_x.func_178782_a().func_177952_p();
                
                int bossX = MathHelper.func_76128_c(mc.field_71439_g.field_70165_t);
                int bossZ = MathHelper.func_76128_c(mc.field_71439_g.field_70161_v);
                int xDirection;
                int zDirection;
                
                if (Math.abs(x - bossX) > Math.abs(z - bossZ))
                {
                    xDirection = (x - bossX > 0) ? 1 : -1;
                    zDirection = 0;
                }
                else
                {
                    xDirection = 0;
                    zDirection = (z - bossZ > 0) ? 1 : -1;
                }

                if (mineAreaShape == 0) // mineshaft
                {
                    setSelectionPoint(0, x, y, z);
                    setSelectionPoint(1, x+4, y, z+4);

                    deleteAdditionalCubes();
                    addAdditionalCube(x+1, y-1, z);
                    addAdditionalCube(x+2, y-2, z);
                    addAdditionalCube(x+3, y-3, z);
                }
                else if (mineAreaShape == 1) // stripmine
                {
                    setSelectionPoint(0, x, y, z);
                    setSelectionPoint(1, x+xDirection*2, y+1, z+zDirection*2);
                }
                else if (mineAreaShape == 2) // custom size
                {
                    int half = ((customSizeXZ-1) / 2);
                    
                    if (xDirection != 0) // advancing in Xdir, start at x and z-half to x+size and z+half
                    {
                        setSelectionPoint(0, x, y, z - half);
                        setSelectionPoint(1, x + (customSizeXZ*xDirection), y + customSizeY-1, z + half);
                    }
                    else
                    {
                        setSelectionPoint(0, x - half, y, z);
                        setSelectionPoint(1, x + half, y + customSizeY-1, z + (customSizeXZ*zDirection));
                    }
                }
            }
        }
        else
        {
            deleteSelection();
        }
        
        if (mc.field_71462_r == null)
        {
            if (Mouse.isButtonDown(0)
            && mc.field_71439_g.field_71071_by.func_70448_g() != null
            && mc.field_71439_g.field_71071_by.func_70448_g().func_77973_b() == MinionsCore.instance.itemMastersStaff
            && lastStaffLightningBoltTime + 100L < System.currentTimeMillis())
            {
                if (MinionsCore.instance.hasPlayerWillPower(mc.field_71439_g))
                {
                    lastStaffLightningBoltTime = System.currentTimeMillis();
                    Entity p = mc.func_175606_aa();
                    MovingObjectPosition pos = p.func_174822_a(10, renderTick);
                    if (pos != null)
                    {
                        Vector3 startvec = Vector3.fromEntityCenter(p).add(0, 0.68D, 0);
                        startvec.x -= (double)(MathHelper.func_76134_b(p.field_70177_z / 180.0F * (float)Math.PI) * 0.16F);
                        //startvec.y -= 0.10000000149011612D;
                        startvec.z -= (double)(MathHelper.func_76126_a(p.field_70177_z / 180.0F * (float)Math.PI) * 0.16F);
                        
                        Vector3 endvec = Vector3.fromVec3(pos.field_72307_f);
                        
                        MinionsCore.instance.networkHelper.sendPacketToServer(
                                new LightningPacket(mc.field_71439_g.func_70005_c_(), startvec.x, startvec.y, startvec.z, endvec.x, endvec.y, endvec.z));
                    }
                }
                else
                {
                    playFartSound(mc.field_71439_g);
                }
            }
            
            if (menuKey.func_151470_d())
            {
                mc.func_147108_a(new GuiMinionMenu());
            }
        }
    }

    public void onPlayerTick(World world)
    {
        if (world != lastWorld && world != null)
        {
            lastWorld = world;
        }
        
        if (FMLCommonHandler.instance().getMinecraftServerInstance() == null)
        {
            // this prevents double updates on local play
            ChickenLightningBolt.update();
        }
    }
    
    private void playFartSound(EntityPlayer player)
    {
        if (timeNextSoundAllowed + timeSoundDelay*2 < System.currentTimeMillis())
        {
            timeNextSoundAllowed = System.currentTimeMillis();
            playSoundToAllPlayersOnServer(player, "minions:fart");
        }
    }
    
    public static void playSoundToAllPlayersOnServer(Entity source, String soundName)
    {
        MinionsCore.instance.networkHelper.sendPacketToServer(new SoundPacket(soundName, source.field_71093_bK, source.func_145782_y()));
    }
    
    public void onMastersGloveRightClick(World worldObj, EntityPlayer playerEnt)
    {
        if (System.currentTimeMillis() > timeNextSoundAllowed)
        {
            // abuse the sound delay to prevent multi-click bugs
            timeNextSoundAllowed = System.currentTimeMillis() + timeSoundDelay;
        }
        else
        {
            return;
        }
        
        Minecraft mcinstance = FMLClientHandler.instance().getClient();
        
        // this raytrace does not hit entities since 1.7!
        MovingObjectPosition targetObjectMouseOver = mcinstance.func_175606_aa().func_174822_a(30.0D, 1.0F);
        // List<EntityMinion> minions = MinionsCore.masterNames.get(playerEnt.getGameProfile().getName());
        MinionsCore.debugPrint("OnMastersGloveRightClick Master: "+playerEnt.func_70005_c_());
        
        if (targetObjectMouseOver == null)
        {
            return;
        }
        
        // have to use the mc object to find entities, short ranged this is
        Entity target = mcinstance.field_71476_x.field_72308_g;
        if (target != null)
        {
            MinionsCore.debugPrint("OnMastersGloveRightClick hit entity "+target);
            if (target instanceof EntityAnimal || target instanceof EntityPlayer)
            {
                MinionsCore.debugPrint("OnMastersGloveRightClick -> PickupEntPacket");
                MinionsCore.instance.networkHelper.sendPacketToServer(new PickupEntPacket(playerEnt.func_70005_c_(), target.func_145782_y()));
            }
            else if (target instanceof EntityMinion)
            {
                MinionsCore.debugPrint("OnMastersGloveRightClick -> DropAllPacket");
                MinionsCore.instance.networkHelper.sendPacketToServer(new DropAllPacket(playerEnt.func_70005_c_(), target.func_145782_y()));
            }
        }
        else if (targetObjectMouseOver.field_72313_a == MovingObjectType.BLOCK)
        {
            int x = targetObjectMouseOver.func_178782_a().func_177958_n();
            int y = targetObjectMouseOver.func_178782_a().func_177956_o() +1;
            int z = targetObjectMouseOver.func_178782_a().func_177952_p();
            
            MinionsCore.debugPrint("OnMastersGloveRightClick coordinate mode, ["+x+"|"+y+"|"+z+"]");

            if (AStarStatic.isPassableBlock(playerEnt.field_70170_p, x, y-1, z))
            {
                y--;
            }

            // System.out("OnMastersGloveRightClick hasAllMinionsSMPOverride: "+hasAllMinionsSMPOverride);
            if (!hasAllMinionsSMPOverride)
            {
                MinionsCore.instance.networkHelper.sendPacketToServer(new MinionSpawnPacket(playerEnt.func_70005_c_(), x, y, z));
                playerEnt.field_70170_p.func_175688_a(EnumParticleTypes.EXPLOSION_HUGE, x, y, z, 0.0D, 0.0D, 0.0D);
                return;
            }

            Block ID = worldObj.func_180495_p(new BlockPos(x, y, z)).func_177230_c();
            TileEntity chestOrInventoryBlock;

            if (MinionsCore.instance.foundTreeBlocks.contains(ID))
            {
                if (MinionsCore.instance.hasPlayerWillPower(playerEnt))
                {
                    MinionsCore.instance.networkHelper.sendPacketToServer(new ChopTreesPacket(playerEnt.func_70005_c_(), x, y, z));
                }
                else
                {
                    playFartSound(playerEnt);
                }
            }
            else if (isSelectingMineArea)
            {
                isSelectingMineArea = false;
                if (mineAreaShape == 0)
                {
                    if (MinionsCore.instance.hasPlayerWillPower(playerEnt))
                    {
                        MinionsCore.instance.networkHelper.sendPacketToServer(new DigStairwellPacket(playerEnt.func_70005_c_(), x, y, z));
                    }
                    else
                    {
                        playFartSound(playerEnt);
                    }
                }
                else if (mineAreaShape == 1)
                {
                    if (MinionsCore.instance.hasPlayerWillPower(playerEnt))
                    {
                        MinionsCore.instance.networkHelper.sendPacketToServer(new StripminePacket(playerEnt.func_70005_c_(), x, y, z));
                    }
                    else
                    {
                        playFartSound(playerEnt);
                    }
                }
                else if (mineAreaShape == 2)
                {
                    if (MinionsCore.instance.hasPlayerWillPower(playerEnt))
                    {
                        MinionsCore.instance.networkHelper.sendPacketToServer(new CustomDigPacket(playerEnt.func_70005_c_(), x, y, z, customSizeXZ, customSizeY));
                    }
                    else
                    {
                        playFartSound(playerEnt);
                    }
                }
            }
            else if ((chestOrInventoryBlock = worldObj.func_175625_s(new BlockPos(x, y-1, z))) != null
                    && chestOrInventoryBlock instanceof IInventory
                    && ((IInventory)chestOrInventoryBlock).func_70302_i_() >= 24)
            {
                MinionsCore.instance.networkHelper.sendPacketToServer(new AssignChestPacket(playerEnt.func_70005_c_(), playerEnt.func_70093_af(), x, y, z));
            }
            else if (AStarStatic.isPassableBlock(playerEnt.field_70170_p, x, y, z) && hasMinionsSMPOverride)
            {
                // check if player targets his own feet. if so, order minion carry
                if (MathHelper.func_76128_c(playerEnt.field_70165_t) == x
                        && MathHelper.func_76128_c(playerEnt.field_70161_v) == z
                        && Math.abs(MathHelper.func_76128_c(playerEnt.field_70163_u) - y) < 3)
                {
                    MinionsCore.instance.networkHelper.sendPacketToServer(new PickupEntPacket(playerEnt.func_70005_c_(), playerEnt.func_145782_y()));
                }
                else
                {
                    MinionsCore.instance.networkHelper.sendPacketToServer(new MovetoPacket(playerEnt.func_70005_c_(), x, y, z));
                }
            }
            else if (MinionsCore.instance.isBlockValueable(worldObj.func_180495_p(new BlockPos(x, y-1, z)).func_177230_c()))
            {
                MinionsCore.instance.networkHelper.sendPacketToServer(new DigOreVeinPacket(playerEnt.func_70005_c_(), x, y, z));
            }
        }
    }
    
    public static void onMastersGloveRightClickHeld(EntityPlayer var3)
    {
        MinionsCore.instance.networkHelper.sendPacketToServer(new FollowPacket(var3.func_70005_c_()));
    }

    public static void onChangedXPSetting()
    {
        if (mc.field_71462_r instanceof GuiMinionMenu)
        {
            mc.field_71462_r = null;

            if (MinionsCore.instance.evilDeedXPCost != -1)
            {
                mc.field_71456_v.func_146158_b().func_146227_a(new ChatComponentText("Server says you don't have enough XP for Evil Deeds"));
            }
            else
            {
                mc.field_71456_v.func_146158_b().func_146227_a(new ChatComponentText("Server says Minions are unobtainable through Evil Deeds here"));
            }
        }
    }

    public static void onMinionMountPacket(int minionID, int targetID)
    {
        Entity minion = mc.field_71441_e.func_73045_a(minionID);
        Entity target = mc.field_71441_e.func_73045_a(targetID);
        if (minion != null && target != null)
        {
            target.func_70078_a(minion);
        }
    }
    
}
