package atomicstryker.minions.common.entity;

import net.minecraft.crash.CrashReport;
import net.minecraft.crash.CrashReportCategory;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.tileentity.TileEntityChest;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.IChatComponent;
import net.minecraft.util.ReportedException;

/**
 * Minion Inventory Class, has some standalone extras compared to a player inventory but no armor
 * 
 * 
 * @author AtomicStryker
 */

public class InventoryMinion implements IInventory
{
    public ItemStack[] mainInventory = new ItemStack[24];
    public EntityMinion minion;
    public boolean inventoryChanged = false;

    public InventoryMinion(EntityMinion var1)
    {
        this.minion = var1;
    }
    
    private int storeItemStack(ItemStack par1ItemStack)
    {
        for (int i = 0; i < this.mainInventory.length; ++i)
        {
            if (this.mainInventory[i] != null && this.mainInventory[i].func_77973_b() == par1ItemStack.func_77973_b() && this.mainInventory[i].func_77985_e() && this.mainInventory[i].field_77994_a < this.mainInventory[i].func_77976_d() && this.mainInventory[i].field_77994_a < this.func_70297_j_() && (!this.mainInventory[i].func_77981_g() || this.mainInventory[i].func_77952_i() == par1ItemStack.func_77952_i()) && ItemStack.func_77970_a(this.mainInventory[i], par1ItemStack))
            {
                return i;
            }
        }

        return -1;
    }
    
    private int getFirstEmptyStack()
    {
        for (int i = 0; i < this.mainInventory.length; ++i)
        {
            if (this.mainInventory[i] == null)
            {
                return i;
            }
        }

        return -1;
    }

    /**
     * This function stores as many items of an ItemStack as possible in a matching slot and returns the quantity of
     * left over items.
     */
    private int storePartialItemStack(ItemStack par1ItemStack)
    {
        Item item = par1ItemStack.func_77973_b();
        int i = par1ItemStack.field_77994_a;
        int j;

        if (par1ItemStack.func_77976_d() == 1)
        {
            j = this.getFirstEmptyStack();

            if (j < 0)
            {
                return i;
            }
            else
            {
                if (this.mainInventory[j] == null)
                {
                    this.mainInventory[j] = ItemStack.func_77944_b(par1ItemStack);
                }

                return 0;
            }
        }
        else
        {
            j = this.storeItemStack(par1ItemStack);

            if (j < 0)
            {
                j = this.getFirstEmptyStack();
            }

            if (j < 0)
            {
                return i;
            }
            else
            {
                if (this.mainInventory[j] == null)
                {
                    this.mainInventory[j] = new ItemStack(item, 0, par1ItemStack.func_77952_i());

                    if (par1ItemStack.func_77942_o())
                    {
                        this.mainInventory[j].func_77982_d((NBTTagCompound)par1ItemStack.func_77978_p().func_74737_b());
                    }
                }

                int k = i;

                if (i > this.mainInventory[j].func_77976_d() - this.mainInventory[j].field_77994_a)
                {
                    k = this.mainInventory[j].func_77976_d() - this.mainInventory[j].field_77994_a;
                }

                if (k > this.func_70297_j_() - this.mainInventory[j].field_77994_a)
                {
                    k = this.func_70297_j_() - this.mainInventory[j].field_77994_a;
                }

                if (k == 0)
                {
                    return i;
                }
                else
                {
                    i -= k;
                    this.mainInventory[j].field_77994_a += k;
                    this.mainInventory[j].field_77992_b = 5;
                    return i;
                }
            }
        }
    }
    
    public boolean addItemStackToInventory(final ItemStack par1ItemStack)
    {
        if (par1ItemStack != null && par1ItemStack.field_77994_a != 0 && par1ItemStack.func_77973_b() != null)
        {
            try
            {
                int i;

                if (par1ItemStack.func_77951_h())
                {
                    i = this.getFirstEmptyStack();

                    if (i >= 0)
                    {
                        this.mainInventory[i] = ItemStack.func_77944_b(par1ItemStack);
                        this.mainInventory[i].field_77992_b = 5;
                        par1ItemStack.field_77994_a = 0;
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
                else
                {
                    do
                    {
                        i = par1ItemStack.field_77994_a;
                        par1ItemStack.field_77994_a = this.storePartialItemStack(par1ItemStack);
                    }
                    while (par1ItemStack.field_77994_a > 0 && par1ItemStack.field_77994_a < i);

                    return par1ItemStack.field_77994_a < i;
                }
            }
            catch (Throwable throwable)
            {
                CrashReport crashreport = CrashReport.func_85055_a(throwable, "Adding item to inventory");
                CrashReportCategory crashreportcategory = crashreport.func_85058_a("Item being added");
                crashreportcategory.func_71507_a("Item ID", Item.func_150891_b(par1ItemStack.func_77973_b()));
                crashreportcategory.func_71507_a("Item data", par1ItemStack.func_77952_i());
                throw new ReportedException(crashreport);
            }
        }
        else
        {
            return false;
        }
    }
    
    public NBTTagList writeToNBT(NBTTagList par1NBTTagList)
    {
        NBTTagCompound nbttagcompound;

        for (int i = 0; i < this.mainInventory.length; ++i)
        {
            if (this.mainInventory[i] != null)
            {
                nbttagcompound = new NBTTagCompound();
                nbttagcompound.func_74774_a("Slot", (byte)i);
                this.mainInventory[i].func_77955_b(nbttagcompound);
                par1NBTTagList.func_74742_a(nbttagcompound);
            }
        }

        return par1NBTTagList;
    }
    
    public void readFromNBT(NBTTagList par1NBTTagList)
    {
        this.mainInventory = new ItemStack[24];

        for (int i = 0; i < par1NBTTagList.func_74745_c(); ++i)
        {
            NBTTagCompound nbttagcompound = par1NBTTagList.func_150305_b(i);
            int j = nbttagcompound.func_74771_c("Slot") & 255;
            ItemStack itemstack = ItemStack.func_77949_a(nbttagcompound);

            if (itemstack != null)
            {
                if (j >= 0 && j < this.mainInventory.length)
                {
                    this.mainInventory[j] = itemstack;
                }
            }
        }
    }
    
    public boolean consumeInventoryItem(Object item)
    {
        int i = this.getFirstSlotWithItem(item);

        if (i < 0)
        {
            return false;
        }
        else
        {
            if (--this.mainInventory[i].field_77994_a <= 0)
            {
                this.mainInventory[i] = null;
            }

            return true;
        }
    }
    
    private int getFirstSlotWithItem(Object item)
    {
        for (int i = 0; i < this.mainInventory.length; ++i)
        {
            if (this.mainInventory[i] != null)
            {
                if (mainInventory[i] == item || mainInventory[i].func_77973_b() == item)
                {
                    return i;
                }
            }
        }

        return -1;
    }
    
    public void dropAllItems()
    {
        int var1;
        for (var1 = 0; var1 < this.mainInventory.length; ++var1)
        {
            if (this.mainInventory[var1] != null)
            {
                this.minion.dropMinionItemWithRandomChoice(this.mainInventory[var1]);
                this.mainInventory[var1] = null;
            }
        }
        minion.inventoryFull = false;
    }

    public boolean containsItems()
    {
        return this.getFirstEmptyStack() != 0;
    }
    
    public void putAllItemsToInventory(IInventory returnChestOrInventory)
    {
        int var1;
        for (var1 = 0; var1 < this.mainInventory.length; ++var1)
        {
            if (this.mainInventory[var1] != null)
            {
                if (addItemStackToInventory(returnChestOrInventory, this.mainInventory[var1]))
                {
                    this.mainInventory[var1] = null;
                }
                else if (returnChestOrInventory instanceof TileEntityChest)
                {
                    TileEntityChest returnChest = (TileEntityChest)returnChestOrInventory;
                    if (returnChest.field_145991_k != null && addItemStackToInventory(returnChest.field_145991_k, this.mainInventory[var1])
                    || returnChest.field_145990_j != null && addItemStackToInventory(returnChest.field_145990_j, this.mainInventory[var1])
                    || returnChest.field_145992_i != null && addItemStackToInventory(returnChest.field_145992_i, this.mainInventory[var1])
                    || returnChest.field_145988_l != null && addItemStackToInventory(returnChest.field_145988_l, this.mainInventory[var1]))
                    {
                        this.mainInventory[var1] = null;
                    }
                }
                else
                {
                    this.dropAllItems();
                    return;
                }
            }
        }
        minion.inventoryFull = false;
    }
    
    private boolean addItemStackToInventory(IInventory inv, ItemStack item)
    {
        int index;
        if (item.func_77984_f() && item.func_77951_h())
        {
            index = getInvFirstEmptyStack(inv);
            if (index >= 0)
            {
                inv.func_70299_a(index, ItemStack.func_77944_b(item));
                inv.func_70301_a(index).field_77992_b = 5;
                item.field_77994_a = 0;
                return true;
            }
            else
            {
                return false;
            }
        }
        else
        {
            do
            {
                index = item.field_77994_a;
                item.field_77994_a = storePartialItemStackInChest(inv, item);
            }
            while (item.field_77994_a > 0 && item.field_77994_a < index);

            return item.field_77994_a < index;
        }
    }
    
    private int storePartialItemStackInChest(IInventory inv, ItemStack item)
    {
        Item itemID = item.func_77973_b();
        int stacksize = item.field_77994_a;
        int index;
        if (item.func_77976_d() == 1)
        {
            index = getInvFirstEmptyStack(inv);
            if (index < 0)
            {
                return stacksize;
            }
            else
            {
                if (inv.func_70301_a(index) == null)
                {
                    inv.func_70299_a(index, ItemStack.func_77944_b(item));
                }

                return 0;
            }
        }
        else
        {
            index = this.storeItemStackInInv(inv, item);
            if (index < 0)
            {
                index = getInvFirstEmptyStack(inv);
            }

            if (index < 0)
            {
                return stacksize;
            }
            else
            {
                if (inv.func_70301_a(index) == null)
                {
                    inv.func_70299_a(index, new ItemStack(itemID, 0, item.func_77952_i()));
                    if (item.func_77942_o())
                    {
                        inv.func_70301_a(index).func_77982_d((NBTTagCompound)item.func_77978_p().func_74737_b());
                    }
                }

                int remainingsize = stacksize;
                if (stacksize > inv.func_70301_a(index).func_77976_d() - inv.func_70301_a(index).field_77994_a)
                {
                    remainingsize = inv.func_70301_a(index).func_77976_d() - inv.func_70301_a(index).field_77994_a;
                }

                if (remainingsize > inv.func_70297_j_() - inv.func_70301_a(index).field_77994_a)
                {
                    remainingsize = inv.func_70297_j_() - inv.func_70301_a(index).field_77994_a;
                }

                if (remainingsize == 0)
                {
                    return stacksize;
                }
                else
                {
                    stacksize -= remainingsize;
                    inv.func_70301_a(index).field_77994_a += remainingsize;
                    inv.func_70301_a(index).field_77992_b = 5;
                    return stacksize;
                }
            }
        }
    }
    
    private int getInvFirstEmptyStack(IInventory inv)
    {
        for (int index = 0; index < inv.func_70302_i_(); ++index)
        {
            if (inv.func_70301_a(index) == null)
            {
                return index;
            }
        }

        return -1;
    }
    
    private int storeItemStackInInv(IInventory inv, ItemStack item)
    {
        for (int index = 0; index < inv.func_70302_i_(); ++index)
        {
            if (inv.func_70301_a(index) != null
            && inv.func_70301_a(index).func_77973_b() == item.func_77973_b()
            && inv.func_70301_a(index).func_77985_e()
            && inv.func_70301_a(index).field_77994_a < inv.func_70301_a(index).func_77976_d()
            && inv.func_70301_a(index).field_77994_a < inv.func_70297_j_()
            && (!inv.func_70301_a(index).func_77981_g() || inv.func_70301_a(index).func_77952_i() == item.func_77952_i()))
            {
                return index;
            }
        }

        return -1;
    }
    
    @Override
    public ItemStack func_70298_a(int par1, int par2)
    {
        ItemStack[] aitemstack = this.mainInventory;

        if (par1 >= this.mainInventory.length)
        {
            return null;
        }

        if (aitemstack[par1] != null)
        {
            ItemStack itemstack;

            if (aitemstack[par1].field_77994_a <= par2)
            {
                itemstack = aitemstack[par1];
                aitemstack[par1] = null;
                return itemstack;
            }
            else
            {
                itemstack = aitemstack[par1].func_77979_a(par2);

                if (aitemstack[par1].field_77994_a == 0)
                {
                    aitemstack[par1] = null;
                }

                return itemstack;
            }
        }
        else
        {
            return null;
        }
    }
    
    @Override
    public ItemStack func_70304_b(int par1)
    {
        return null;
    }

    @Override
    public void func_70299_a(int par1, ItemStack par2ItemStack)
    {
        ItemStack[] aitemstack = this.mainInventory;

        if (par1 < aitemstack.length)
        {
            aitemstack[par1] = par2ItemStack;
        }
    }

    @Override
    public int func_70302_i_()
    {
        return this.mainInventory.length + 4;
    }
    
    @Override
    public ItemStack func_70301_a(int par1)
    {
        return mainInventory[par1];
    }
    
    @Override
    public int func_70297_j_()
    {
        return 64;
    }

    @Override
    public void func_70296_d()
    {
        this.inventoryChanged = true;
    }

    @Override
    public boolean func_70300_a(EntityPlayer par1EntityPlayer)
    {
        return false;
    }
    
    @Override
    public boolean func_94041_b(int par1, ItemStack par2ItemStack)
    {
        return true;
    }

    @Override
    public String func_70005_c_()
    {
        return "Minion Inventory";
    }

    @Override
    public boolean func_145818_k_()
    {
        return true;
    }

    @Override
    public IChatComponent func_145748_c_()
    {
        return new ChatComponentText(func_70005_c_());
    }

    @Override
    public void func_174889_b(EntityPlayer player)
    {
    }

    @Override
    public void func_174886_c(EntityPlayer player)
    {
    }

    @Override
    public int func_174887_a_(int id)
    {
        return 0;
    }

    @Override
    public void func_174885_b(int id, int value)
    {
    }

    @Override
    public int func_174890_g()
    {
        return 0;
    }

    @Override
    public void func_174888_l()
    {
    }
    
}
