package atomicstryker.minions.common.entity;

import atomicstryker.minions.common.MinionsCore;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.pathfinding.PathNavigate;
import net.minecraft.util.BlockPos;
import net.minecraft.util.MathHelper;

public class MinionAIFollowMaster extends EntityAIBase
{

    private final EntityMinion theMinion;
    private final float followSpeed;
    private final PathNavigate petPathfinder;
    private final float maxDist;
    private final float minDist;

    private int updateTicker;
    private final double followRangeSq;

    public MinionAIFollowMaster(EntityMinion minion, float movespeed, float min, float max)
    {
        this.theMinion = minion;
        this.followSpeed = movespeed;
        this.petPathfinder = minion.func_70661_as();
        this.minDist = min;
        this.maxDist = max;
        this.func_75248_a(3);
        followRangeSq = MinionsCore.instance.minionFollowRange * MinionsCore.instance.minionFollowRange;
    }

    /**
     * Returns whether the EntityAIBase should begin execution.
     */
    @Override
    public boolean func_75250_a()
    {
        return theMinion.master != null && theMinion.func_70068_e(theMinion.master) > (double) (this.minDist * this.minDist)
                && shouldFollowMaster();
    }

    /**
     * Returns whether an in-progress EntityAIBase should continue executing
     */
    @Override
    public boolean func_75253_b()
    {
        return !this.petPathfinder.func_75500_f() && this.theMinion.func_70068_e(theMinion.master) > (double) (this.maxDist * this.maxDist)
                && shouldFollowMaster();
    }

    /**
     * Execute a one shot task or start executing a continuous task
     */
    @Override
    public void func_75249_e()
    {
        this.updateTicker = 0;
        theMinion.setWorking(false);
    }

    /**
     * Resets the task
     */
    @Override
    public void func_75251_c()
    {
        this.petPathfinder.func_75499_g();
    }

    /**
     * Updates the task
     */
    @Override
    public void func_75246_d()
    {
        theMinion.func_70671_ap().func_75651_a(theMinion.master, 10.0F, (float) theMinion.func_70646_bf());

        if (shouldFollowMaster())
        {
            if (--updateTicker <= 0)
            {
                updateTicker = 30;

                if (!petPathfinder.func_75497_a(theMinion.master, followSpeed))
                {
                    if (theMinion.func_70068_e(theMinion.master) >= followRangeSq)
                    {
                        int x = MathHelper.func_76128_c(theMinion.master.field_70165_t) - 2;
                        int z = MathHelper.func_76128_c(theMinion.master.field_70161_v) - 2;
                        int y = MathHelper.func_76128_c(theMinion.master.func_174813_aQ().field_72338_b);

                        for (int xIter = 0; xIter <= 4; ++xIter)
                        {
                            for (int zIter = 0; zIter <= 4; ++zIter)
                            {
                                if ((xIter < 1 || zIter < 1 || xIter > 3 || zIter > 3)
                                        && theMinion.field_70170_p.func_180495_p(new BlockPos(x + xIter, y - 1, z + zIter)).func_177230_c().func_149721_r()
                                        && !theMinion.field_70170_p.func_180495_p(new BlockPos(x + xIter, y, z + zIter)).func_177230_c().func_149721_r()
                                        && !theMinion.field_70170_p.func_180495_p(new BlockPos(x + xIter, y + 1, z + zIter)).func_177230_c().func_149721_r())
                                {
                                    theMinion.func_70012_b((double) (x + xIter) + 0.5D, (double) y, (double) (z + zIter) + 0.5D,
                                            theMinion.field_70177_z, theMinion.field_70125_A);
                                    petPathfinder.func_75499_g();
                                    return;
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    private boolean shouldFollowMaster()
    {
        return theMinion.followingMaster || (theMinion.returningGoods && theMinion.returnChestOrInventory == null);
    }
}
