package atomicstryker.minions.common.entity;

import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.ai.EntityAIBase;

public class MinionAIStalkAndGrab extends EntityAIBase
{
    private EntityMinion theMinion;
    private EntityLivingBase target;

    int grabDelay = 0;
    final int maxGrabDelay = 20;
    float moveSpeed;

    public MinionAIStalkAndGrab(EntityMinion minion, float par2)
    {
        this.theMinion = minion;
        this.moveSpeed = par2;
        this.func_75248_a(3);
        target = null;
    }

    /**
     * Returns whether the EntityAIBase should begin execution.
     */
    @Override
    public boolean func_75250_a()
    {
        if (theMinion.targetEntityToGrab != null)
        {
            target = theMinion.targetEntityToGrab;
            return true;
        }
        
        target = null;
        return false;
    }

    /**
     * Returns whether an in-progress EntityAIBase should continue executing
     */
    @Override
    public boolean func_75253_b()
    {
        return target != null && target.func_70089_S() && this.grabDelay < maxGrabDelay;
    }

    /**
     * Resets the task
     */
    @Override
    public void func_75251_c()
    {
        this.target = null;
        this.grabDelay = 0;
        theMinion.targetEntityToGrab = null;
    }

    /**
     * Updates the task
     */
    @Override
    public void func_75246_d()
    {
        this.theMinion.func_70671_ap().func_75651_a(this.target, 10.0F, (float)this.theMinion.func_70646_bf());
        this.theMinion.func_70661_as().func_75497_a(this.target, this.moveSpeed);
        ++this.grabDelay;

        if (this.grabDelay == maxGrabDelay)
        {
            target.func_70078_a(theMinion);
            func_75251_c();
        }
    }
}
